package jbmf.parser.constants;


import jbmf.utils.ByteUtil;

public class ClassConstant extends Constant {
    private int nameIndex;

    public ClassConstant(byte[] data) {
        super(data);
        nameIndex = ByteUtil.readU2(data, 0);
    }

    public int getNameIndex() {
        return this.nameIndex;
    }

    public void setNameIndex(int nameIndex) {
        this.nameIndex = nameIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_CLASS;
    }

    @Override
    public int getSize() {
        return CONSTANT_CLASS_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, nameIndex);
    }

    @Override
    public String toString() {
        return "[ClassConstant nameIndex=" + nameIndex + "]";
    }
}
