package jbmf.parser.constants;

public abstract class Constant implements Constants {

    protected byte[] data;

    public Constant(byte[] data) {
        assert data != null;
        assert(data.length == getSize());

        this.data = data;
    }

    public byte[] getData() {
        pack();
        return data;
    }

    @Override
    public String toString() {
        return "[Tag: " + getTag() + "]";
    }

    /**
     * Returns the tag value
     * @return the tag value
     */
    public abstract int getTag();

    /**
     * Returns the size in bytes or 1 when the size is variable
     * @return the size in bytes (tag byte excl.)
     */
    public abstract int getSize();

    /**
     * Pack the current state of the Constant back in the data bytes.
     */
    public abstract void pack();

}
