package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class DoubleConstant extends Constant {

    private double value;
    private boolean init;
    private boolean dirty;

    public DoubleConstant(byte[] data) {
        super(data);
    }

    public double getValue() {
        if(init) {
            return value;
        }

        init = true;
        long bits = ByteUtil.readU8(data, 0);
        return value = Double.longBitsToDouble(bits);
    }

    public void setValue(double value) {
        dirty = init = true;
        this.value = value;
    }

    @Override
    public int getTag() {
        return CONSTANT_DOUBLE;
    }

    @Override
    public int getSize() {
        return CONSTANT_DOUBLE_SIZE;
    }

    @Override
    public void pack() {
        if(dirty) {
            long bits = Double.doubleToRawLongBits(value);
            ByteUtil.writeU8(data, 0, bits);
        }

        dirty = !dirty;
    }

    @Override
    public String toString() {
        getValue();
        return "[DoubleConstant value=" + value + "]";
    }
}
