package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class FloatConstant extends Constant {

    private float value;
    private boolean init;
    private boolean dirty;

    public FloatConstant(byte[] data) {
        super(data);
    }

    public float getValue() {
        if(init) {
            return value;
        }

        init = true;
        return value = Float.intBitsToFloat(ByteUtil.readU4(data, 0));
    }

    public void setValue(float value) {
        dirty = init = true;
        this.value = value;
    }

    @Override
    public int getTag() {
        return CONSTANT_FLOAT;
    }

    @Override
    public int getSize() {
        return CONSTANT_FLOAT_SIZE;
    }

    @Override
    public void pack() {
        if(dirty) {
            ByteUtil.writeU4(data, 0, Float.floatToRawIntBits(value));
        }

        dirty = !dirty;
    }

    @Override
    public String toString() {
        getValue();
        return "[FloatConstant value=" + value + "]";
    }
}
