package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class IFaceMethodRefConstant extends Constant {

    private int classIndex;
    private int nameAndTypeIndex;

    public IFaceMethodRefConstant(byte[] data) {
        super(data);

        classIndex = ByteUtil.readU2(data, 1);
        nameAndTypeIndex = ByteUtil.readU2(data, 3);
    }

    public int getClassIndex() {
        return classIndex;
    }

    public void setClassIndex(int classIndex) {
        this.classIndex = classIndex;
    }

    public int getNameAndTypeIndex() {
        return nameAndTypeIndex;
    }

    public void setNameAndTypeIndex(int nameAndTypeIndex) {
        this.nameAndTypeIndex = nameAndTypeIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_IFACEMTHODREF;
    }

    @Override
    public int getSize() {
        return CONSTANT_IFACEMETHODREF_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 1, classIndex);
        ByteUtil.writeU2(data, 3, nameAndTypeIndex);
    }

    @Override
    public String toString() {
        return "[IFaceMethodRefConstant classIndex=" + classIndex + ", nameAndTypeIndex=" + nameAndTypeIndex + "]";
    }

}
