package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class IntegerConstant extends Constant {

    private int value;
    private boolean init;
    private boolean dirty;

    public IntegerConstant(byte[] data) {
        super(data);
    }

    public int getValue() {
        if(init) {
            return value;
        }

        init = true;
        return value = ByteUtil.readU4(data, 0);
    }

    public void setValue(int value) {
        dirty = init = true;
        this.value = value;
    }

    @Override
    public int getTag() {
        return CONSTANT_INTEGER;
    }

    @Override
    public int getSize() {
        return CONSTANT_INTEGER_SIZE;
    }

    @Override
    public void pack() {
        if(dirty) {
            ByteUtil.writeU4(data, 0, value);
        }

        dirty = !dirty;
    }

    @Override
    public String toString() {
        getValue();
        return "[IntegerConstant value=" + value + "]";
    }
}
