package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class InvokeDynamicConstant extends Constant {

    private int bootstrapMethodIndex;
    private int nameAndTypeIndex;

    public InvokeDynamicConstant(byte[] data) {
        super(data);

        bootstrapMethodIndex = ByteUtil.readU2(data, 0);
        nameAndTypeIndex = ByteUtil.readU2(data, 2);
    }

    public int getBootstrapMethodIndex() {
        return bootstrapMethodIndex;
    }

    public void setBootstrapMethodIndex(int bootstrapMethodIndex) {
        this.bootstrapMethodIndex = bootstrapMethodIndex;
    }

    public int getNameAndTypeIndex() {
        return nameAndTypeIndex;
    }

    public void setNameAndTypeIndex(int nameAndTypeIndex) {
        this.nameAndTypeIndex = nameAndTypeIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_INVOKEDYNAMIC;
    }

    @Override
    public int getSize() {
        return CONSTANT_INVOKEDYNAMIC_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, bootstrapMethodIndex);
        ByteUtil.writeU2(data, 2, nameAndTypeIndex);
    }

    @Override
    public String toString() {
        return "[InvokeDynamicConstant bootStrapMethodIndex=" + bootstrapMethodIndex + ", nameAndTypeIndex=" + nameAndTypeIndex + "]";
    }

}
