package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class LongConstant extends Constant {

    private long value;
    private boolean init;
    private boolean dirty;

    public LongConstant(byte[] data) {
        super(data);
    }

    public long getValue() {
        if(init) {
            return value;
        }

        init = true;
        return value = ByteUtil.readU8(data, 0);
    }

    public void setValue(long value) {
        dirty = init = true;
        this.value = value;
    }

    @Override
    public int getTag() {
        return CONSTANT_LONG;
    }

    @Override
    public int getSize() {
        return CONSTANT_LONG_SIZE;
    }

    @Override
    public void pack() {
        if(dirty) {
            ByteUtil.writeU8(data, 0, value);
        }

        dirty = !dirty;
    }

    @Override
    public String toString() {
        getValue();
        return "[LongConstant value=" + value + "]";
    }
}
