package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class MethodHandleConstant extends Constant {

    private int referenceKind;
    private int referenceIndex;

    public MethodHandleConstant(byte[] data) {
        super(data);

        referenceIndex = ByteUtil.readU1(data, 0);
        referenceIndex = ByteUtil.readU2(data, 1);
    }

    public int getReferenceKind() {
        return referenceKind;
    }

    public void setReferenceKind(int referenceKind) {
        this.referenceKind = referenceKind;
    }

    public int getReferenceIndex() {
        return referenceIndex;
    }

    public void setReferenceIndex(int referenceIndex) {
        this.referenceIndex = referenceIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_METHODHANDLE;
    }

    @Override
    public int getSize() {
        return CONSTANT_METHODHANDLE_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU1(data, 0, referenceKind);
        ByteUtil.writeU2(data, 1, referenceIndex);
    }

    @Override
    public String toString() {
        return "[MethodHandleConstant referenceKind=" + referenceKind + ", referenceIndex=" + referenceIndex + "]";
    }
}
