package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class MethodRefConstant extends Constant {

    private int classIndex;
    private int nameAndTypeIndex;

    public MethodRefConstant(byte[] data) {
        super(data);

        classIndex = ByteUtil.readU2(data, 0);
        nameAndTypeIndex = ByteUtil.readU2(data, 2);
    }

    public int getClassIndex() {
        return classIndex;
    }

    public void setClassIndex(int classIndex) {
        this.classIndex = classIndex;
    }

    public int getNameAndTypeIndex() {
        return nameAndTypeIndex;
    }

    public void setNameAndTypeIndex(int nameAndTypeIndex) {
        this.nameAndTypeIndex = nameAndTypeIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_METHODREF;
    }

    @Override
    public int getSize() {
        return CONSTANT_METHODREF_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, classIndex);
        ByteUtil.writeU2(data, 2, nameAndTypeIndex);
    }

    @Override
    public String toString() {
        return "[MethodRefConstant classIndex=" + classIndex + ", nameAndTypeIndex=" + nameAndTypeIndex + "]";
    }

}
