package jbmf.parser.constants;


import jbmf.utils.ByteUtil;

public class MethodTypeConstant extends Constant {

    private int descriptorIndex;

    public MethodTypeConstant(byte[] data) {
        super(data);

        descriptorIndex = ByteUtil.readU2(data, 0);
    }

    public int getDescriptorIndex() {
        return descriptorIndex;
    }

    public void setDescriptorIndex(int descriptorIndex) {
        this.descriptorIndex = descriptorIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_METHODTYPE;
    }

    @Override
    public int getSize() {
        return CONSTANT_METHODTYPE_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, descriptorIndex);
    }

    @Override
    public String toString() {
        return "[MethodTypeConstant descriptorIndex=" + descriptorIndex + "]";
    }
}
