package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class NameAndTypeConstant extends Constant {

    private int nameIndex;
    private int descriptorIndex;

    public NameAndTypeConstant(byte[] data) {
        super(data);

        nameIndex = ByteUtil.readU2(data, 0);
        descriptorIndex = ByteUtil.readU2(data, 2);
    }

    public int getNameIndex() {
        return nameIndex;
    }

    public void setNameIndex(int nameIndex) {
        this.nameIndex = nameIndex;
    }

    public int getDescriptorIndex() {
        return descriptorIndex;
    }

    public void setDescriptorIndex(int descriptorIndex) {
        this.descriptorIndex = descriptorIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_NAMEANDTYPE;
    }

    @Override
    public int getSize() {
        return CONSTANT_NAMEANDTYPE_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, nameIndex);
        ByteUtil.writeU2(data, 2, descriptorIndex);
    }

    @Override
    public String toString() {
        return "[NameAndTypeConstant nameIndex=" + nameIndex + ", descriptorIndex =" + descriptorIndex + "]";
    }
}
