package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

public class StringConstant extends Constant {

    private int stringIndex;

    public StringConstant(byte[] data) {
        super(data);
        stringIndex = ByteUtil.readU2(data, 0);
    }

    public int getStringIndex() {
        return stringIndex;
    }

    public void setStringIndex(int stringIndex) {
        this.stringIndex = stringIndex;
    }

    @Override
    public int getTag() {
        return CONSTANT_STRING;
    }

    @Override
    public int getSize() {
        return CONSTANT_STRING_SIZE;
    }

    @Override
    public void pack() {
        ByteUtil.writeU2(data, 0, stringIndex);
    }

    @Override
    public String toString() {
        return "[StringConstant stringIndex=" + stringIndex + "]";
    }
}
