package jbmf.parser.constants;

import jbmf.utils.ByteUtil;

import java.io.*;

public class UTF8Constant extends Constant {

    private int lenInBytes;
    private String value;

    public UTF8Constant(byte[] data) {
        super(data);

        try {
            value = new String(data, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        this.lenInBytes = data.length;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public int getTag() {
        return CONSTANT_UTF8;
    }

    @Override
    public int getSize() {
        return lenInBytes + CONSTANT_UTF8_SIZE;
    }

    @Override
    public void pack() {
        //todo check
        try {
            data = value.getBytes("UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }

    @Override
    public String toString() {
        return "[UTF8Constant value=" + value + "]";
    }

}
