package jbmf.utils;


public class TimingUtil {

    public static final int TIMING_NS = 1;
    public static final int TIMING_MS = 1000000;
    public static final int TIMING_S = 1000000000;

    private String msg;
    private long start;
    private long amount;
    private double min;
    private double max;
    private double total;
    private int timing;

    public TimingUtil(String msg) {
        this(msg, TIMING_MS);
    }

    public TimingUtil(String msg, int timing) {
        assert msg != null;
        assert timing > -1;

        this.msg = msg;
        this.timing = timing;
    }

    public void start() {
        start = System.nanoTime();
    }

    public void stop() {
        long t = System.nanoTime() - start;
        assert t != 0;

        amount++;
        double ms = t / timing;
        total += ms;
        min = (ms < min) || (min == 0) ? ms : min;
        max = ms > max ? ms : max;
    }

    public void feedback() {
        System.out.println("===Timing util===");
        System.out.println("Test: " + msg);
        System.out.println("Timing in: ms");
        System.out.println("Measurements: " + amount);
        System.out.println("Total time: " + total);
        System.out.println("Avg time: " + (double)(total/amount));
        System.out.println("Min time: " + min);
        System.out.println("Max time: " + max);
        System.out.println("===End timing===");
    }
}
